"use strict";
/* eslint-disable @typescript-eslint/strict-boolean-expressions */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var crypto_1 = require("crypto");
var path_1 = require("path");
var fs_1 = require("mz/fs");
var zlib_1 = require("mz/zlib");
var mime_types_1 = require("mime-types");
var compressible_1 = __importDefault(require("compressible"));
var fs_readdir_recursive_1 = __importDefault(require("fs-readdir-recursive"));
var prefix = '/';
// eslint-disable-next-line @typescript-eslint/no-explicit-any,@typescript-eslint/explicit-function-return-type
var loadFile = function (name, dir, options, files) {
    var pathname = (0, path_1.normalize)((0, path_1.join)(prefix, name));
    var obj = (files[pathname] = files[pathname] ? files[pathname] : {});
    var filename = (obj.path = (0, path_1.join)(dir, name));
    var stats = (0, fs_1.statSync)(filename);
    var buffer = (0, fs_1.readFileSync)(filename);
    obj.cacheControl = options.cacheControl;
    // eslint-disable-next-line @typescript-eslint/prefer-nullish-coalescing
    obj.maxAge = obj.maxAge ? obj.maxAge : options.maxAge || 0;
    obj.type = obj.mime = (0, mime_types_1.lookup)(pathname) || 'application/octet-stream';
    obj.mtime = stats.mtime;
    obj.length = stats.size;
    obj.md5 = (0, crypto_1.createHash)('md5').update(buffer).digest('base64');
    obj.buffer = buffer;
    buffer = null;
    return obj;
};
var simpleStatic = function (options) {
    var dir = (0, path_1.normalize)(options.dir);
    var files = {};
    (0, fs_readdir_recursive_1.default)(dir).forEach(function (name) {
        loadFile(name, dir, options, files);
    });
    // eslint-disable-next-line max-statements
    return function (ctx, next) { return __awaiter(void 0, void 0, void 0, function () {
        var filename, file, hasIndex, _a, fullPath, s, _b, stats, acceptGzip, shouldGzip, _c, stream, hash_1;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    if (!!['HEAD', 'GET'].includes(ctx.method)) return [3 /*break*/, 2];
                    return [4 /*yield*/, next()];
                case 1:
                    _d.sent();
                    return [2 /*return*/];
                case 2:
                    if (!!ctx.path.startsWith(prefix)) return [3 /*break*/, 4];
                    return [4 /*yield*/, next()];
                case 3:
                    _d.sent();
                    return [2 /*return*/];
                case 4:
                    if (options.extraHeaders &&
                        Array.isArray(options.extraHeaders) &&
                        options.extraHeaders.length) {
                        options.extraHeaders.forEach(function (header) {
                            for (var h in header) {
                                ctx.append(h, header[h]);
                            }
                        });
                    }
                    filename = decodeURIComponent((0, path_1.normalize)(ctx.path));
                    file = files[filename];
                    if (!!file) return [3 /*break*/, 20];
                    if (!(0, path_1.basename)(filename).startsWith('.')) return [3 /*break*/, 6];
                    return [4 /*yield*/, next()];
                case 5:
                    _d.sent();
                    return [2 /*return*/];
                case 6:
                    hasIndex = false;
                    _d.label = 7;
                case 7:
                    _d.trys.push([7, 9, , 10]);
                    return [4 /*yield*/, (0, fs_1.statSync)((0, path_1.normalize)((0, path_1.join)(dir, "".concat(filename, "/index.html")))).isFile()
                        /* eslint-enable @typescript-eslint/await-thenable */
                    ];
                case 8:
                    /* eslint-disable @typescript-eslint/await-thenable */
                    hasIndex = _d.sent();
                    return [3 /*break*/, 10];
                case 9:
                    _a = _d.sent();
                    return [3 /*break*/, 10];
                case 10:
                    if (hasIndex) {
                        filename = "".concat(filename, "/index.html");
                    }
                    if (filename.startsWith(path_1.sep)) {
                        filename = filename.slice(1);
                    }
                    fullPath = (0, path_1.join)(dir, filename);
                    if (!(!fullPath.startsWith(dir) && fullPath !== 'index.html')) return [3 /*break*/, 12];
                    return [4 /*yield*/, next()];
                case 11:
                    _d.sent();
                    return [2 /*return*/];
                case 12:
                    s = void 0;
                    _d.label = 13;
                case 13:
                    _d.trys.push([13, 15, , 17]);
                    return [4 /*yield*/, (0, fs_1.statSync)((0, path_1.join)(dir, filename))];
                case 14:
                    // eslint-disable-next-line @typescript-eslint/await-thenable
                    s = _d.sent();
                    return [3 /*break*/, 17];
                case 15:
                    _b = _d.sent();
                    return [4 /*yield*/, next()];
                case 16:
                    _d.sent();
                    return [2 /*return*/];
                case 17:
                    if (!!s.isFile()) return [3 /*break*/, 19];
                    return [4 /*yield*/, next()];
                case 18:
                    _d.sent();
                    return [2 /*return*/];
                case 19:
                    file = loadFile(filename, dir, options, files);
                    _d.label = 20;
                case 20:
                    ctx.status = 200;
                    ctx.vary('Accept-Encoding');
                    if (!!file.buffer) return [3 /*break*/, 22];
                    return [4 /*yield*/, (0, fs_1.statSync)(file.path)];
                case 21:
                    stats = _d.sent();
                    if (stats.mtime > file.mtime) {
                        file.mtime = stats.mtime;
                        file.md5 = null;
                        file.length = stats.size;
                    }
                    _d.label = 22;
                case 22:
                    ctx.response.lastModified = file.mtime;
                    if (file.md5) {
                        ctx.response.etag = file.md5;
                    }
                    if (ctx.fresh) {
                        ctx.status = 304;
                        return [2 /*return*/];
                    }
                    ctx.type = file.type;
                    ctx.length = file.zipBuffer ? file.zipBuffer.length : file.length;
                    // eslint-disable-next-line @typescript-eslint/restrict-template-expressions
                    ctx.set('cache-control', "public, max-age=".concat(file.maxAge));
                    if (file.md5) {
                        ctx.set('content-md5', file.md5);
                    }
                    if (ctx.method === 'HEAD') {
                        return [2 /*return*/];
                    }
                    acceptGzip = ctx.acceptsEncodings('gzip') === 'gzip';
                    if (file.zipBuffer) {
                        if (acceptGzip) {
                            ctx.set('content-encoding', 'gzip');
                            ctx.body = file.zipBuffer;
                        }
                        else {
                            ctx.body = file.buffer;
                        }
                        return [2 /*return*/];
                    }
                    shouldGzip = file.length > 1024 && acceptGzip && (0, compressible_1.default)(file.type);
                    if (!file.buffer) return [3 /*break*/, 26];
                    if (!shouldGzip) return [3 /*break*/, 24];
                    _c = file;
                    return [4 /*yield*/, (0, zlib_1.gzip)(file.buffer)];
                case 23:
                    _c.zipBuffer = _d.sent();
                    ctx.set('content-encoding', 'gzip');
                    ctx.body = file.zipBuffer;
                    return [3 /*break*/, 25];
                case 24:
                    ctx.body = file.buffer;
                    _d.label = 25;
                case 25: return [2 /*return*/];
                case 26: return [4 /*yield*/, (0, fs_1.createReadStream)(file.path)
                    // update file hash
                ];
                case 27:
                    stream = _d.sent();
                    // update file hash
                    if (!file.md5) {
                        hash_1 = (0, crypto_1.createHash)('md5');
                        stream.on('data', hash_1.update.bind(hash_1));
                        stream.on('end', function () {
                            file.md5 = hash_1.digest('base64');
                        });
                    }
                    ctx.body = stream;
                    // enable gzip will remove content length
                    if (shouldGzip) {
                        ctx.remove('content-length');
                        ctx.set('content-encoding', 'gzip');
                        ctx.body = stream.pipe((0, zlib_1.createGzip)());
                    }
                    return [2 /*return*/];
            }
        });
    }); };
};
exports.default = simpleStatic;
